!      10.10.7.0
!   09.07.2025 .
! ----------------------------------------------
! Admin (2019 .): https://forum.clarionlife.net/viewtopic.php?t=4420
!  :  https://forum.clarionlife.net/viewtopic.php?t=4420
! LibCurl & cJSON: https://github.com/mikeduglas
! ----------------------------------------------

  Include('Atol.equ'),Once    ! 
  Include('DynStr.inc'),Once  !    
  Include('cJSON.inc'),Once   !   JSON !  ! : true/false/"ignore" -  lowercase !
  
  ! ---  

  Map
    Module('Atol')
      Atol::UnicodeToASCII(String pStr),String
      Atol::ASCIIToUnicode(String pStr),String
      Atol::Message(String sText,Byte bAddMode = 0)     ! 
                                                        !      GS1                           
      Atol::RecodeMarking(String xMarking_,Bool bFNC1 = False),String      
                                                        !   
      Atol::AskMe(String sText,Byte bDefaultButton = Button:Yes),Byte
      Atol::SplitUTC(Byte bVid,String sDateUTC),Long    !  UTC 
                                                        !    2003 "     "
      Atol::Calc2003(Byte bCheckType,String sFractionalAmount),String
                                                        !    2106 "    "
      Atol::Calc2106(*Atol:G_ItemInfoCheckResult gItemInfoCheckResult),byte
      
                                                        !    1199 " " 
      Atol::Calc1199(Byte bTaxRate = 255,Bool bNoNDS = False),String
                                                        !    1199      1214
      Atol::Rate1199(String sMethod,Byte bTaxRate = 255,Bool bNoNDS = False),String
      
      Atol::Nick1212(String sObject),String             !      1212 "  "      
      Atol::Nick1214(String sMethod),String             !      1214 "   " 
      
      Atol::Calc2108(Long lOKEI,String sUnit),Byte      !    2108 "  "      
      Atol::Nick2108(Long lOKEI,String sUnit),String    !      2108 "  "
      
      Atol::NickTPay(Byte bType),String                 !   c         
      Atol::MarkToBase64(String pStr),String            !  : TEXT -> GS1 -> BASE64
      Atol::View(*Queue qList)                          !    
      Atol::CreateNewItem(*Atol:Q_Items qItems)         !        
      Atol::CreateNewOutItem(*Atol:G_OutItem gOutItem)  !     
      Atol::SetFileISO(),String                         !   JSON     / 
      Atol::ExecuteFromJson(<*Atol:G_Connect gConnect>) !    JSON       
      Atol::OpenProtocolFolder()                        !        10
                                                        !     
      Atol::ProblemVatin(String sVatin,<*String sError>),Bool      
                                                        !      
      Atol::CreateFullRow(Byte bTapeWidth, String sLeft, String sRight),String
                                                        ! 1291 / 1292     -   
      Atol::SetFractionalAmount(Long lNumerator,Long lDenominator),String
    end
    Module('Windows API')
      Atol::Sleep(Long),Pascal,Name('Sleep')
    end
  end

  ! --- 
  
!    TYPE / VARIABLE
! L / l -> LONG
! B / b -> BYTE (BOOL)    
! R / r -> REAL
! D / d -> DECIMAL
! S / s -> STRING
! C / c -> CSTRING
! G / g -> GROUP
! Q / q -> QUEUE
! I / i -> IDynStr
! J / j -> cJSON
! E     -> EQUATE  

Atol:fiscalDriveNumber     CString(17)   !         " "

Atol:J_ALL     Equate('{{"Name":"*","EmptyString":"ignore","IgnoreZero":true,"IgnoreEmptyObject":true,"IgnoreEmptyArray":true}')       

  Section('_Declare_Atol_Connect_')
  
  Compile('*** LEGACY ***',Atol:Legacy = 1)
! ---        
  
!*** LEGACY ***

Atol:G_Connect       Group,Type              ! ---    
Model                  Byte(0)               !     (.  Atol10.Connect())
LibFptrModel           uShort(0)             !       (      )
ReConnect              Bool(False)           !     
Exclusive              Bool(False)           !    10 ( )
SetClockFR             Bool(False)           !       
SetOFD                 Byte(0)               !   
Port                   Byte(0)               !  
ComFile                Byte(0)               !  COM-  1  255
BaudRate               Byte(0)               !    COM 
IPAddr                 CString( 41)          ! TCP/IP  / MAC 
IPPort                 CString( 21)          ! TCP/IP 
InvertCash             Byte(0)               !    
DocJourUse             Byte(0)               !   
                                             !      
DocJourPath            CString(File:MaxFileName)
PassAccess             CString( 41)          !    
PassUser               CString( 41)          !    
RServer                CString(129)          !     
RTimeOut               Byte(0)               !        (*1000)
InfoText               UShort(0)             !   
SilentReboot           Byte(0)               !  
                     end

!!!  ()
Atol:G_Operator      Group,Type                 
name                   CString(129)          ! 1021 
vatin                  CString( 13)          ! 1203 
                     end                

!!!                     
Atol:G_ClientInfo    Group,Type              ! 1256
emailOrPhone           CString(129)          ! 1008 E-mail     (  -  )
name                   CString(129)          ! 1227  
vatin                  CString( 13)          ! 1228  
birthDate              CString( 11)          ! 1243   (  1.2)   ".."	
citizenship            CString(  4)          ! 1244  (  1.2)   "",  	
identityDocumentCode   CString(  3)          ! 1245   ,   (  1.2)   "",  	
identityDocumentData   CString(129)          ! 1246  ,   (  1.2)
address                CString(129)          ! 1254  / (  1.2)
                     end
Atol:J_ClientInfo    Equate('{{"Name":["emailOrPhone","birthDate","identityDocumentCode","identityDocumentData"],"JsonName":"*"}')
                            
  Section('_End_Atol_Connect_')

!!!   
Atol:G_CompanyInfo        Group,Type
email                       CString(129)     ! 1117 E-mail    
                          end 

!!!   ( 1260    1261  )
Atol:G_IndustryInfo       Group,Type
fois                        CString(  4)     ! 1262         ( - "",  )
date                        CString( 11)     ! 1263    ( - "yyyy.mm.dd") -> @D010.
number                      CString( 65)     ! 1264   
industryAttribute           CString(256)     ! 1265   
                          end
Atol:J_IndustryInfo       Equate('{{"Name":"industryAttribute","JsonName":"industryAttribute"}')

!!! 2106     
Atol:G_ItemInfoCheckResult  Group,Type
imcCheckFlag                  Bool           ! -  0       () 
imcCheckResult                Bool           ! -  1      (true)   (false)
imcStatusInfo                 Bool           ! -  2     ( 2106,  2)
imcEstimatedStatusCorrect     Bool           ! -  3        
ecrStandAloneFlag             Bool           ! -  4      ,    
                            end
Atol:J_ItemInfoCheckResult  Equate('{{"Name":"imcCheckFlag","JsonName":"imcCheckFlag","IsBool":true},'     & |
                                   '{{"Name":"imcCheckResult","JsonName":"imcCheckResult","IsBool":true},' & | 
                                   '{{"Name":"imcStatusInfo","JsonName":"imcStatusInfo","IsBool":true},'   & |
                                   '{{"Name":"imcEstimatedStatusCorrect","JsonName":"imcEstimatedStatusCorrect","IsBool":true},' & |
                                   '{{"Name":"ecrStandAloneFlag","JsonName":"ecrStandAloneFlag","IsBool":true}')                                   
!!!                     
Atol:G_AgentInfo          Group,Type
agents                      CString(41),Dim(7)    !  ( 1057  , 1222  )
agentsPrint                 Bool(True)            !   " " ( 1222)   - true
agentDataPrint              Bool(True)            !   " "  ( 1223)   - true
payingAgent                 Group                 !   
operation                     CString( 41)        ! 1044   
phones                        CString(129),Dim(3) ! 1073   
                            end
receivePaymentsOperator     Group                 !     
phones                        CString(129),Dim(3) ! 1074     
                            end
moneyTransferOperator       Group                 !   
phones                        CString(129),Dim(3) ! 1075   
name                          CString(129)        ! 1026   
address                       CString(129)        ! 1005   
vatin                         CString( 13)        ! 1016   
                            end
                          end
Atol:J_AgentInfo          Equate('{{"Name":"payingAgent","JsonName":"payingAgent"},' & |
                                 '{{"Name":"receivePaymentsOperator","JsonName":"receivePaymentsOperator"},' & |
                                 '{{"Name":"moneyTransferOperator","JsonName":"moneyTransferOperator"},' & |
                                 '{{"Name":"agentsPrint","JsonName":"agentsPrint","IsBool":true,"IgnoreTrue":true},' & |
                                 '{{"Name":"agentDataPrint","JsonName":"agentDataPrint","IsBool":true,"IgnoreTrue":true}')
                                 
!!! 1270    (  )
Atol:G_OperationInfo      Group,Type
id                          Byte                ! 1271   (number 0-255)
data                        CString(129)        ! 1272  
dateTime                    CString(41)         ! 1273 ,   ( - "yyyy.mm.dd HH:MM:SS")
                          end
Atol:J_OperationInfo      Equate('{{"Name":"dateTime","JsonName":"dateTime"}')

!!! 1224  
Atol:G_SupplierInfo       Group,Type
phones                      CString(129),Dim(9) ! 1171  
name                        CString(129)        ! 1225  
vatin                       CString( 13)        ! 1226  
supplierPrint               Bool(True)          !   " " ( 1224)   - true
supplierVatinPrint          Bool(True)          !   " "    ( 1226)   - true
                          end
Atol:J_SupplierInfo       Equate('{{"Name":"supplierPrint","JsonName":"supplierPrint","IsBool":true,"IgnoreTrue":true},' & |
                                 '{{"Name":"supplierVatinPrint","JsonName":"supplierVatinPrint","IsBool":true,"IgnoreTrue":true}')
!!! 
Atol:G_Tax                Group,Type
type                        CString(21)         ! 1199  
sum                         Decimal(13,2,0)     ! 1120  .     ,   
                          end                   ! (  -  )

!!!  
Atol:G_CustomParameters   Group,Type
id                          Long                !  
value                       CString(256)        !  
                          end
                 
Atol:G_UserAttribute      Group,Type            ! 1084              
name                        CString(121)        ! 1085  
value                       CString(256)        ! 1086  
                          end
                 
!!!   -->    ! :(
Atol:G_SalesNotice        Group,Type            ! 1084   
userAttribute               Group(Atol:G_UserAttribute).
                          end
                                                 ! 1084    
!Atol:G_SalesNotice        Group(Atol:G_UserAttribute),Type
!                          end                          
Atol:J_SalesNotice        Equate('{{"Name":"userAttribute","JsonName":"userAttribute"}')

!!!      (OFFLINE )
Atol:G_OfflineValidation  Group,Type          
fmCheck                     Bool             ! 2004  0:    
fmCheckResult               Bool             ! 2004  1:  
fmCheckErrorReason          CString(21)      !    
                          end
Atol:J_OfflineValidation  Equate('{{"name":["fmCheck","fmCheckResult"],"IsBool":true}')

!!!                                   
Atol:G_DriverError        Group,Type
code                        Long             !    
error	                    CString(121)     !    ()
description	                CString(256)     !   
                          end

!!! 2005      
Atol:G_MarkOperatorResponse  Group,Type
responseStatus                 Bool          !      (true)   (false)
itemStatusCheck                Bool          !   
                             end
Atol:J_MarkOperatorResponse  Equate('{{"name":["responseStatus","itemStatusCheck"],"IsBool":true}')
                                    
!!!                              
Atol:G_OnlineValidation   Group,Type
itemInfoCheckResult         Group(Atol:G_ItemInfoCheckResult).   !     
markOperatorResponse        Group(Atol:G_MarkOperatorResponse).  ! 2005      
markOperatorItemStatus      CString( 41)     ! 2109    
markOperatorResponseResult  CString( 41)     ! 2105   
imcType                     CString(121)     ! 2100   
imcBarcode                  CString(256)     ! 2101  
imcModeProcessing           Long             ! 2102    
                          end
Atol:J_OnlineValidation   Equate(Atol:J_ItemInfoCheckResult & ',' & Atol:J_MarkOperatorResponse)
                                 
!!!  
Atol:G_ValidateMark       Group,Type
ready                       Bool                                !     
sentImcRequest              Bool                                !      
driverError                 Group(Atol:G_DriverError).          !  
onlineValidation            Group(Atol:G_OnlineValidation).     !    
                          end
Atol:J_ValidateMark       Equate('{{"name":["ready","sentImcRequest"],"IsBool":true},' & |
                                 Atol:J_OnlineValidation)       ! +    Atol:J_ItemInfoCheckResult                                 
                                 
!!!   
Atol:Q_ValidateMarks      Queue,Type
driverError                 Group(Atol:G_DriverError).          !  
itemInfoCheckResult         Group(Atol:G_ItemInfoCheckResult).  !      -   
offlineValidation           Group(Atol:G_OfflineValidation).    !    -
onlineValidation            Group(Atol:G_OnlineValidation).     !    
sentImcRequest              Bool                                !      
                          end
Atol:J_ValidateMarks      Equate('{{"name":["ready","sentImcRequest"],"IsBool":true},' & |
                                 Atol:J_OfflineValidation& ',' & |
                                 Atol:J_OnlineValidation)       ! +    Atol:J_ItemInfoCheckResult
                                 
!!!       
Atol:Q_AddMarksToBuffer   Queue,Type
driverError                 Group(Atol:G_DriverError).          !  
offlineValidation           Group(Atol:G_OfflineValidation).    !    -
itemInfoCheckResult         Group(Atol:G_ItemInfoCheckResult).  !     
                          end
Atol:J_AddMarksToBuffer   Equate(Atol:J_OfflineValidation & ',' & Atol:J_ItemInfoCheckResult)

!!!    / 
Atol:G_FiscalParams       Group,Type
fiscalDocumentDateTime      CString(41)      ! 1012    
fiscalDocumentNumber        Long             ! 1040   
fiscalDocumentSign          CString(41)      ! 1077  
fnNumber                    CString(41)      ! 1041  
fnsUrl                      CString(81)      ! 1060   
registrationNumber          CString(41)      ! 1037 
shiftNumber                 Long             ! 1038  
                          end
                          
!!!   (warnings)                          
Atol:G_Warnings           Group
notPrinted                  Bool             !  ,      
                          end
Atol:J_Warnings           Equate('{{"name":"notPrinted","IsBool":true}') 

!!!  
Atol:G_DocParams          Group,Type
fiscalParams                Group(Atol:G_FiscalParams).  ! -   
warnings                    Group(Atol:G_Warnings).      ! -   
                          end
Atol:J_DocParams          Equate(Atol:J_Warnings)

!!!    
Atol:G_CheckResponse      Group,Type
fiscalParams                Group(Atol:G_FiscalParams)   ! -   
fiscalReceiptNumber           Long                       !    
total                         Real                       ! 
                            end
warnings                    Group(Atol:G_Warnings).      !   
validateMarks               &Atol:Q_ValidateMarks        !      
                          end
Atol:J_CheckResponse      Equate(Atol:J_Warnings)
                 
!!!    
Atol:G_CashDrawerStatus   Group,Type
cashDrawerStatus            Group
cashDrawerOpened              Bool               !   
                            end
counters                    Group
cashSum                       Real               !    
	                        end
                          end
Atol:J_CashDrawerStatus   Equate('{{"name":"cashDrawerOpened","IsBool":true}')

!!!                             
Atol:G_QuantityCounter    Group,Type
corrections                 Long                 !  
count                       Long                 !    ( )
                          end
                          
!!!   
Atol:G_TotalCounter       Group,Type
receipts                    Long                 !    ( )
corrections                 Long                 !  
receiptsSum                 Real                 !    ( )
correctionsSum              Real                 !  
cashSum                     Real                 !   
noncashSum                  Real                 !   
prepaidSum                  Real                 !   
creditSum                   Real                 !   
barterSum                   Real                 !    
vat20Sum                    Real                 ! 1102   20%
vat10Sum                    Real                 ! 1103   10%
vat120Sum                   Real                 ! 1106   20/120
vat110Sum                   Real                 ! 1107   10/110
vat0Sum                     Real                 ! 1104   0%
vatNoSum                    Real                 ! 1105   
                          end
                          
!!!   
Atol:G_NotSendCounter     Group,Type
sum                         Real                 !    ( )
count                       Long                 !    ( )
                          end                          
!!! 
Atol:G_Error              Group,Type
code                        Long                 !  
description                 CString(255)         !  
                          end
!!!                             
Atol:G_ExchangeErrors     Group,Type
network                     Group(Atol:G_Error). !  
ofd                         Group(Atol:G_Error). !  
ism                         Group(Atol:G_Error). !  
fn                          Group(Atol:G_Error). !  
documentNumber              Long                 !  ,    
fnCommandCode               Long                 !  ,    
lastSuccessConnectionDateTime CString(41)        !        
                          end 
                          
!!!    
Atol:G_Status             Group
notSentCount                Long                 ! 1097   
notSentFirstDocNumber       Long                 ! 1116    
notSentFirstDocDateTime     CString(41)          ! 1098      
                          end                           

!!!    
Atol:G_ReportOfdExchangeStatus  Group,Type
fiscalParams                      Group          ! -   
fiscalDocumentNumber                Long         ! 1040   
fiscalDocumentSign                  CString(21)  ! 1077  
fiscalDocumentDateTime              CString(41)  ! 1012    
shiftNumber                         Long         ! 1038  
fnNumber                            CString(21)  ! 1041  
fnQuantityCounters                  Group        ! --   
shiftNumber                           Long       ! 1038  
countAll                              Long       !    ( )
sell                                  Group(Atol:G_QuantityCounter).  !  
buy                                   Group(Atol:G_QuantityCounter).  !  
sellReturn                            Group(Atol:G_QuantityCounter).  !   
buyReturn                             Group(Atol:G_QuantityCounter).  !   
                                    end
fnTotals                            Group        ! --   
sell                                  Group(Atol:G_TotalCounter).     !  
buy                                   Group(Atol:G_TotalCounter).     !  
sellReturn                            Group(Atol:G_TotalCounter).     !   
buyReturn                             Group(Atol:G_TotalCounter).     !   
                                    end
fnUnsentDocsCounters                Group        ! -- 1158     
countAll                              Long       !    ( )
sell                                  Group(Atol:G_NotSendCounter).   !  
buy                                   Group(Atol:G_NotSendCounter).   !  
sellReturn                            Group(Atol:G_NotSendCounter).   !   
buyReturn                             Group(Atol:G_NotSendCounter).   !   
                                    end  
registrationNumber                  CString(41)  ! 1037 
fnsUrl                              CString(81)  ! 1060   
                                  end
status                            Group(Atol:G_Status).          ! -     
errors                            Group(Atol:G_ExchangeErrors).  ! -                                                   
warnings                          Group(Atol:G_Warnings).        ! -   
                                end
Atol:J_ReportOfdExchangeStatus  Equate(Atol:J_Warnings)

!!!  
Atol:G_ExchangeWarnings   Group,Type       ! -  
dataForSendIsEmpty	        Bool           !    
                          end
Atol:J_ExchangeWarnings   Equate('{{"name":"dataForSendIsEmpty","IsBool":true}')
                          
!!!!     
Atol:G_OfdExchangeStatus  Group,Type    
status                      Group(Atol:G_Status)             ! -  
lastSuccessKeysUpdate	      CString(41)                    !      
                            end 
errors                      Group(Atol:G_ExchangeErrors).    ! -  
warnings                    Group(Atol:G_ExchangeWarnings).  ! -  
                          end
Atol:J_OfdExchangeStatus  Equate(Atol:J_ExchangeWarnings)

!!!     
Atol:G_IsmExchangeStatus  Group,Type
status                      Group(Atol:G_Status).            ! -  
errors                      Group(Atol:G_ExchangeErrors).    ! -                   
warnings                    Group(Atol:G_ExchangeWarnings).  ! -                                    
                          end
Atol:J_IsmExchangeStatus  Equate(Atol:J_ExchangeWarnings)

Atol:G_Receipts           Group,Type                 
count                       Long           !  
sum                         Real           !   
payments                    Group          ! -  
cash                          Real         !   
electronically                Real         !   
credit                        Real         !  
prepaid                       Real         !  
other                         Real         !    
userPaymentType5              Real         !       
userPaymentType6              Real         !       
userPaymentType7              Real         !       
userPaymentType8              Real         !       
userPaymentType9              Real         !       
                            end
                          end
Atol:J_Receipts           Equate('{{"Name":"userPaymentType5","JsonName":"userPaymentType-5"},' & |
                                 '{{"Name":"userPaymentType6","JsonName":"userPaymentType-6"},' & |
                                 '{{"Name":"userPaymentType7","JsonName":"userPaymentType-7"},' & |
                                 '{{"Name":"userPaymentType8","JsonName":"userPaymentType-8"},' & |
                                 '{{"Name":"userPaymentType9","JsonName":"userPaymentType-9"}')                                
!!!     
Atol:G_GetShiftTotals     Group,Type
shiftNumber                 Long           !  ,   ,     ,  
cashDrawer                  Group          ! -    
sum                           Real         !     
                            end
income                      Group          ! -  
count                         Long         !   
sum                           Real         !   
                            end
outcome                     Group          ! -  
count                         Long         !   
sum                           Real         !   
                            end
receipts                    Group          ! -  
buy                           Group(Atol:G_Receipts).  !    
buyReturn                     Group(Atol:G_Receipts).  !     
sell                          Group(Atol:G_Receipts).  !    
sellReturn                    Group(Atol:G_Receipts).  !     
                            end                                    
                          end
Atol:J_GetShiftTotals     Equate(Atol:J_Receipts)
                                
!!!   
Atol:G_GetOverallTotals   Group,Type
receipts                    Group          ! -  
buy                           Group(Atol:G_Receipts).  !    
buyReturn                     Group(Atol:G_Receipts).  !     
sell                          Group(Atol:G_Receipts).  !    
sellReturn                    Group(Atol:G_Receipts).  !     
                            end 
                          end
                                
Atol:G_DepartmentSum      Group,Type
buy                         Real             !    
buyReturn                   Real             !     
sell                        Real             !    
sellReturn                  Real             !     
                          end                   
                                
!!!       
Atol:G_GetDepartmentSum   Group,Type
department1                 Group(Atol:G_DepartmentSum).
department2                 Group(Atol:G_DepartmentSum).
department3                 Group(Atol:G_DepartmentSum).
department4                 Group(Atol:G_DepartmentSum).
department5                 Group(Atol:G_DepartmentSum).
                          end
                         
!!!     < 1.2                         
Atol:G_MarkingCode        Group,Type
type	                    CString( 11)     !   (other -      2.0   3.0
                                             !            egais20 -  2.0
                                             !            egais30 -  3.0);	  - other
mark	                    CString(256)     ! base64-   
                          end

!!!     >= 1.2                         
Atol:G_ImcParams          Group
imcType	                    CString( 41)     ! 2100    (auto -    )
imc	                        CString(513)     ! 2000 base64 -    
imcModeProcessing	        Long             ! 2102    
imcBarcode	                CString(256)     ! 2101     base64-
itemEstimatedStatus	        CString( 41)     ! 2003   
itemQuantity	            Long             ! 1023  ;     
itemUnits	                CString( 41)     ! 2108   ;     
itemFractionalAmount	    CString( 41)     ! 1291    
                                             ! 2106      
itemInfoCheckResult  	    Group(Atol:G_ItemInfoCheckResult).
                          end
Atol:J_ImcCommon          Equate('{{"Name":"imcType","JsonName":"imcType"},'  & |
                                 '{{"Name":"imcModeProcessing","JsonName":"imcModeProcessing","IgnoreZero":false},'  & |
                                 '{{"Name":"imcBarcode","JsonName":"imcBarcode"},'  & |
                                 '{{"Name":"itemEstimatedStatus","JsonName":"itemEstimatedStatus"},'   & |
                                 '{{"Name":"itemQuantity","JsonName":"itemQuantity"},'  & |
                                 '{{"Name":"itemUnits","JsonName":"itemUnits"},' & |
                                 '{{"Name":"itemFractionalAmount","JsonName":"itemFractionalAmount"},' & |
                                 Atol:J_ItemInfoCheckResult)
                                 
Atol:J_ImcParams          Equate('{{"Name":"itemInfoCheckResult","JsonName":"itemInfoCheckResult"},' & Atol:J_ImcCommon)
Atol:J_ImcValidate        Equate('{{"Name":"itemInfoCheckResult","Ignore":true},'                    & Atol:J_ImcCommon)                                

!!!     /     ( >= 1.2)
Atol:Q_ImcParams          Queue(Atol:G_ImcParams).

!!! 1163  
Atol:G_Codes              Group,Type       
codes                       CString(256),Dim(5)   !   (   )
undefined                   CString(33)           ! 1300   
ean8                        CString(9)            ! 1301  EAN-8
ean13	                    CString(14)           ! 1302  EAN-13
itf14                       CString(15)           ! 1303  ITF-14
gs10                        CString(39)           ! 1304  GS1.0
gs1m                        CString(201)          ! 1305  GS1.M
short                       CString(61)           ! 1306   (  )
furs                        CString(41)           ! 1307   ( )
egais20                     CString(256)          ! 1308  -2.0
egais30                     CString(256)          ! 1309  -3.0
f1                          CString(121)          ! 1320  .1
f2                          CString(121)          ! 1321  .2
f3                          CString(121)          ! 1322  .3
f4                          CString(121)          ! 1323  .4
f5                          CString(121)          ! 1324  .5
f6                          CString(121)          ! 1325  .6
                          end

!!!   -> 
Atol:G_Text               Group,Type
type                        CString( 41)          ! +  
text                        Any                   !   (  -   ( ))
alignment	                CString( 21)          !  (left / center / right)   - left
wrap	                    CString( 21)          ! 
font	                    Byte                  !  (   )
doubleWidth	                Bool(False)           !  
doubleHeight	            Bool(False)           !  
storeInJournal	            Bool(True)            !    
                          end

!!!      -    -> Atol:G_Text  ANY
Atol:G_Overlay            Group,Type
type                        CString( 41)          ! +  
text                        CString(129)          !   (  -   ( ))
alignment	                CString( 21)          !  (left / center / right)   - left
wrap	                    CString( 21)          ! 
font	                    Byte                  !  (   )
doubleWidth	                Bool(False)           !  
doubleHeight	            Bool(False)           !  
storeInJournal	            Bool(True)            !    
                          end                          

!!!   -> -
Atol:G_BarCode            Group,Type
barcode	                    Any                   !   (   barcodeType)
barcodeType                 CString(21)	          !  
alignment	                CString(21)           !  (left / center / right)   - center
scale	                    Long                  !   (  - 1)
height	                    Long                  !  (   )   - 30
printText	                Bool(False)           !    (   )
                                                  !       (   ("type": "text"))
overlay                     Group(Atol:G_Overlay),Dim(5).
storeInJournal	            Bool(True)            !     (  QR-)
                          end
                  
!!!   ->  ( )
Atol:G_Pixels             Group,Type
pixels	                    Any                   !    BASE64
width	                    Long                  !    
scale	                    Long                  !   	( - 100)
alignment	                CString(21)           ! 	(left / center / right)   - center
                          end

!!!   ->    
Atol:G_PictureFromMemory  Group,Type
pictureNumber	            Long                  !  
alignment	                CString(21)           ! 	(left / center / right)   - center
                          end
                          
!!!   ->    ( 1084)
Atol:G_ItemUserAttribute  Group(Atol:G_UserAttribute),Type
print	                    Bool(True)            !         (  true)
                          end

!!!   ->    () ( 1192)
Atol:G_AdditionalAttribute Group,Type
value	                     CString(256)         !     ()
print	                     Bool(True)           !         (  true)
                           end                          
                  
!!!    ()                  
Atol:G_OutItem            Group(Atol:G_Text),Type
barcode	                    Any                   !   (   barcodeType)
barcodeType                 CString(21)	          !  
scale	                    Long                  !   (  - 1)
height	                    Long                  !  (   )   - 30
printText	                Bool(False)           !    (   )
                                                  !       (   ("type": "text"))  
overlay                     Group(Atol:G_Overlay),Dim(5).
pixels	                    Any                   !    BASE64
width	                    Long                  !    
pictureNumber	            Long                  !     

name                        CString(121)          ! 1085  
value                       CString(256)          ! 1086   /    ()
print	                    Bool(True)            !         (  true)
                          end
Atol:J_OutItems           Equate('{{"Name":"barcodeType","JsonName":"barcodeType"},'     & |
                                 '{{"Name":"pictureNumber","JsonName":"pictureNumber"},' & |
                                 |
                                 '{{"Name":"doubleWidth","JsonName":"doubleWidth","IsBool":true,"IgnoreFalse":true},'   & |
                                 '{{"Name":"doubleHeight","JsonName":"doubleHeight","IsBool":true,"IgnoreFalse":true},' & |
                                 '{{"Name":"printText","JsonName":"printText","IsBool":true,"IgnoreFalse":true},'       & |                                 
                                 |
                                 '{{"Name":"print","IsBool":true,"IgnoreTrue":true},'    & |
                                 '{{"Name":"storeInJournal","JsonName":"storeInJournal","IsBool":true,"IgnoreTrue":true}')
                  
!!!    ()
Atol:Q_OutItems           Queue(Atol:G_OutItem),Type.

!!!  
Atol:G_Payments           Group,Type
type                        CString(21)                    !  
sum                         Decimal(13,2)                  !  
printItems                  Group(Atol:G_Overlay),Dim(5).  !      ( text)
                          end
                          
!!! 1235     (    -   !)
Atol:G_ElectronInfo       Group,Type
sum                         Decimal(13,2)                  ! 1082  
paymentMethod               Byte                           ! 1236     (   1214 -   !)
electronicallyId            CString(129)                   ! 1237   
electronicallyAddInfo       CString(129)                   ! 1238     
                          end

!!!   /  
Atol:G_ResponseShift      Group,Type
fiscalParams                Group(Atol:G_FiscalParams)     ! -    / 
receiptsCount                 Long                         ! -    (  )
                            end
warnings                    Group(Atol:G_Warnings).        !  
                          end
Atol:J_ResponseShift      Equate(Atol:J_Warnings)

!!!  
Atol:Q_DeviceParameters   Queue,Type
key                         Long             !   ( )
value                       CString(257)     !  
errorCode                   Long             !  
errorDescription            CString(121)     !  
                          end    

!!!    
Atol:G_DeviceInfo         Group,Type
configurationVersion        CString(41)      !  
ffdVersion                  CString(41)      ! 1189   
firmwareVersion             CString(41)      !  
fnFfdVersion                CString(41)      ! 1190   
model                       Long             !  
modelName                   CString(41)      !  
receiptLineLength           Long             !     
receiptLineLengthPix        Long             !     
serial                      CString(41)      ! 1013   
                          end
                      
!!!   
Atol:G_DeviceStatus       Group,Type
currentDateTime	            CString(41)      !     
shift	                    CString(11)      !  : closed -  / opened -  / expired - 
blocked	                    Bool             !  
coverOpened	                Bool             !  
paperPresent	            Bool             !   
fiscal	                    Bool             !  
fnFiscal     	            Bool             !  
fnPresent	                Bool             !  
cashDrawerOpened	        Bool             !   
                          end
Atol:J_DeviceStatus       Equate('{{"name":["blocked","coverOpened","paperPresent","fiscal","fnFiscal",' & | 
                                           '"fnPresent","cashDrawerOpened"],"IsBool":true}')
                             
!!!     ( ) 
Atol:G_Organization       Group,Type
name	                    CString(129)          ! 1048  
vatin	                    CString( 13)          ! 1018  
email	                    CString(129)          ! 1117 E-mail  (   )
address	                    CString(129)          ! 1009  
taxationTypes	            CString( 41),Dim(6)   ! 1062   
agents                      CString( 41),Dim(8)   ! 1057  
                          end
Atol:J_Organization       Equate('{{"Name":"taxationTypes","JsonName":"taxationTypes"}')                        

!!!                           
Atol:G_Device             Group,Type
registrationNumber          CString( 41)          ! 1037   
fnsUrl                      CString(129)          ! 1060   
offlineMode                 Bool                  ! 1002   
machineInstallation         Bool                  ! 1221     
bso                         Bool                  ! 1110   
encryption                  Bool                  ! 1056  
autoMode                    Bool                  ! 1001   
machineNumber               CString( 41)          ! 1036  
internet                    Bool                  ! 1108       
service                     Bool                  ! 1109    
excise                      Bool                  ! 1207   
gambling                    Bool                  ! 1193    
lottery                     Bool                  ! 1126   
defaultTaxationType         CString( 41)          ! 1055   
ofdChannel                  CString( 41)          !    
ffdVersion                  CString( 11)          ! 1209  
paymentsAddress             CString(129)          ! 1187  
insurance                   Bool                  !    
marking                     Bool                  !    
pawnShop                    Bool                  !    
vending                     Bool                  !     
catering                    Bool                  !    . 
wholesale                   Bool                  !   
                          end
Atol:J_Device             Equate('{{"name":["registrationNumber","fnsUrl","machineNumber","defaultTaxationType",' & | 
                                           '"ofdChannel","ffdVersion","paymentsAddress"],"JsonName":"*"},' & |
                                 |
                                 '{{"name":"offlineMode","IsBool":true,"JsonName":"offlineMode"},'   & |
                                 '{{"name":"machineInstallation","IsBool":true,"JsonName":"machineInstallation"},' & |
                                 '{{"name":"autoMode","IsBool":true,"JsonName":"autoMode"},' & |
                                 '{{"name":"pawnShop","IsBool":true,"JsonName":"pawnShop"},' & |
                                 |
                                 '{{"name":["bso","encryption","internet","service","excise","gambling","lottery",' & | 
                                           '"insurance","marking","vending","catering","wholesale"],"IsBool":true}')
!!!                                 
Atol:G_Ofd                Group,Type
name	                     CString(129)    ! 1046  
vatin	                     CString( 13)    ! 1017  
host	                     CString(129)    !  
port                         uShort          !    (0 - 65535)	
dns                          CString( 41)    ! DNS   
                          end
!!!  
Atol:G_Ism                Group,Type
host                        CString(129)     !  
port                        uShort           !    (0 - 65535)
                          end

!!!    
Atol:G_RegistrationInfo   Group,Type              
organization                Group(Atol:G_Organization).  ! -    ( ) 
device                      Group(Atol:G_Device).        ! -  
ofd                         Group(Atol:G_Ofd).           ! -  
ism                         Group(Atol:G_Ism).           ! -  
                          end                             
Atol:J_RegistrationInfo   Equate(Atol:J_Organization & ',' & Atol:J_Device)
                               
Atol:G_Registration       Group(Atol:G_RegistrationInfo),Type
type                        CString(41)
operator                    Group(Atol:G_Operator).
reason                      CString(21)            !   ( 1.05)
changeInfoReasons           Byte,Dim(32)           !      ( 1.1)
electronically              Bool(False)            !   (  )
                          end
Atol:J_Registration       Equate('{{"Name":"electronically","IsBool":true,"IgnoreFalse":true},'  & |
                                 '{{"Name":"changeInfoReasons","JsonName":"changeInfoReasons"},' & | 
                                 Atol:J_RegistrationInfo)                               
!!!   
Atol:G_ShiftStatus        Group,Type
documentsCount	            Long             !     (   )
expiredTime	                CString(41)      !      ( ,     )
number	                    Long             !  ,    /    ,  
state	                    CString(11)      !  : closed -  / opened -  / expired - 
                          end                !   :   "status"

!!!     
Atol:G_PingIsm            Group,Type
ready	                    Bool             !      	boolean
time	                    Long             !    , 	number
                          end
Atol:J_PingIsm            Equate('{{"name":"ready","IsBool":true}')

!!!    
Atol:G_ValidationReady    Group,Type
ValidationReady	            Bool             !      (boolean)
                          end
Atol:J_ValidationReady    Equate('{{"name":"validationReady","IsBool":true}')

!!!    
Atol:G_CheckImcTime       Group,Type
fmCheckTime                 Long             !    , 
sendingTime                 Long             !  , 
serverExchangeTime          Long             !    , 
fullTime                    Long             !   , 
                          end

!!!                           
Atol:G_CheckImcWorkState  Group,Type
fm                          Group
status	                      CString(41)    !   
checkingCount	              Long           !   
soldImcCount	              Long           !   
noticeIsBegin	              Bool           !   
noticeFreeMemory              CString(41)    !   	string
noticeCount	                  Long           !   
                            end
ecr                         Group
status	                      CString(41)    !   
type	                      CString(41)    !   
stage	                      CString(41)    !   
                            end                             
                          end
Atol:J_CheckImcWorkState  Equate('{{"name":"noticeIsBegin","IsBool":true}')

!!!      
Atol:G_GetFnDocument      Group,Type
type                        CString('getFnDocument')
fiscalDocumentNumber        Long(0)
withRawData                 Bool(False) 
                          end
Atol:J_GetFnDocument      Equate('{{"Name":"fiscalDocumentNumber","JsonName":"fiscalDocumentNumber"},' & |
                                 '{{"Name":"withRawData","JsonName":"withRawData","IsBool":true}')
                                 
!!!    
Atol:G_WinFnDocument      Group,Type
documentTLV                 Group
T1000                         CString(256), Name('1000')  !  
T1008                         CString(129), Name('1008')  !  (E-Mail / )
T1009                         CString(256), Name('1009')  !  
T1012                         CString( 41), Name('1012')  !     
T1018                         CString( 13), Name('1018')  !  ()
T1020                         CString( 41), Name('1020')  !  
T1021                         CString( 41), Name('1021')  !  ()
T1031                         CString( 41), Name('1031')  !    () 
T1036                         CString( 21), Name('1036')  !  
T1037                         CString( 41), Name('1037')  !   
T1038                         CString( 41), Name('1038')  !  
T1040                         CString( 41), Name('1040')  !     ()
T1041                         CString( 41), Name('1041')  !    ()
T1042                         CString( 41), Name('1042')  !     
T1048                         CString( 81), Name('1048')  !  ()
T1054                         CString( 11), Name('1054')  !  
T1055                         CString( 11), Name('1055')  !   
T1060                         CString(121), Name('1060')  !   
T1077                         CString( 41), Name('1077')  !   
T1078                         CString( 41), Name('1078')  !   
T1081                         CString( 41), Name('1081')  !    () 
T1084                         CString(256), Name('1084')  !   
T1102                         CString( 21), Name('1102')  !      20%
T1103                         CString( 21), Name('1103')  !      10%
T1104                         CString( 21), Name('1104')  !         0%
T1105                         CString( 21), Name('1105')  !      
T1106                         CString( 21), Name('1106')  !     .  20/120
T1107                         CString( 21), Name('1107')  !     .  10/110
T1108                         CString( 21), Name('1108')  !     "  "
T1117                         CString( 81), Name('1117')  !  (E-Mail)
T1187                         CString(256), Name('1187')  !   
T1192                         CString(256), Name('1192')  !    ()
T1196                         CString(256), Name('1192')  ! QR-
T1203                         CString( 13), Name('1203')  !  ()
T1209                         CString(  3), Name('1209')  !   
T1215                         CString( 41), Name('1215')  !    () 
T1216                         CString( 41), Name('1216')  !    () 
T1217                         CString( 41), Name('1217')  !    ()  
T1227                         CString( 81), Name('1227')  !  ()
T1228                         CString( 13), Name('1228')  !  ()
T1243                         CString( 13), Name('1243')  !  ( )
T1244                         CString(  4), Name('1244')  !  ()
T1245                         CString(  3), Name('1245')  !  (  )
T1246                         CString(256), Name('1246')  !  ( )
T1254                         CString(256), Name('1254')  !  ()
T1256                         CString(256), Name('1256')  !    / 
T1270                         CString(256), Name('1270')  !   
fiscalDocumentType            CString( 81), Name('fiscalDocumentType')  !  
Tshort                        CString( 11), Name('short') !    false / true
TQR                           CString(256), Name('qr')    ! QR 
Q1059                         &Queue,       Name('1059')  !  ר ( )
!Q1261                                                    !   
!Q2107                                                    !    
                            end
rawData                     CString(8193),Name('rawData') !     TLV,   base64
                          end                  
!!!  
Atol:G_FnWarnings         Group,Type
memoryOverflow              Bool                   !   
needReplacement             Bool                   !    
ofdTimeout                  Bool                   !      
resourceExhausted           Bool                   !   
criticalError               Bool                   !   
                          end
Atol:J_FnWarnings         Equate('{{"name":"memoryOverflow","IsBool":true},'    & |
                                 '{{"name":"needReplacement","IsBool":true},'   & |
                                 '{{"name":"ofdTimeout","IsBool":true},'        & |
                                 '{{"name":"resourceExhausted","IsBool":true},' & |
                                 '{{"name":"criticalError","IsBool":true}')                  
!!!    
Atol:G_FnInfo             Group,Type
serial                      CString(41)            !   
version                     CString(41)            !  
execution                   CString(41)            !   (  -)
numberOfRegistrations       Long                   !   
registrationsRemaining      Long                   !   
validityDate                CString(41)            !   
ffdVersion	                CString(21)            !   
fnContainsKeysUpdaterServerUri Bool                !   URI  
fnFfdVersion                CString(21)            !   
livePhase                   CString(41)            !   
warnings                    Group(Atol:G_FnWarnings).  !  
                          end 
Atol:J_FnInfo             Equate('{{"Name":"fnContainsKeysUpdaterServerUri","IsBool":true},' & Atol:J_FnWarnings)

!!!   
Atol:G_FnStatus           Group,Type
fiscalDocumentNumber        Long                       !   
fiscalReceiptNumber         Long                       !    
warnings                    Group(Atol:G_FnWarnings).  !  
                          end
Atol:J_FnStatus           Equate(Atol:J_FnWarnings)   

!!!     /    
Atol:Q_Licenses           Queue,Type
id                          CString(41)            !   /  
name                        CString(81)            !   /  
                          end
                     
!!!   
Atol:G_Mcu           Group,Type
dataFlash              Group
jedecId                  Long                      ! JEDEC ID DataFlash
name                     CString(129)              !   DataFlash
size                     Long                      !   DataFlash  
                       end
framEeprom             Group
name                     CString(129)              !   FRAM/EEPROM
size                     Long                      !   FRAM/EEPROM  
                       end 
mcu                    Group
partId                   CString(129)              !   
partName                 CString(129)              !   
sn                       CString(129)              !   
                       end  
                     end
                     
!!!   
Atol:G_Header       Group,Type                    
CheckType             Byte(0)                      !   (LIBFPTR_PARAM_RECEIPT_TYPE)
TaxType               Byte(0)                      ! 1055    ()
PrintTaxation         Bool(False)                  !       
 
Electronically        Bool(False)                  !   (    )
Internet              Bool(False)                  ! 1125    ""
OpenDrawer            Bool(False)                  !   
Total                 Decimal(13,2,0)              !   (   )
NameInOneLine         Bool(False)                  !       
UploadToFile          CString(File:MaxFileName)    !     JSON 

ignoreNonFiscalPrintErrors  Bool(False)            !      
paymentsPlace         CString(121)                 ! 1187    (     "")
emailOrPhone          CString(121)                 ! 1008       
paymentsAddress       CString(121)                 ! 1009     1.2
machineNumber         CString( 41)                 ! 1036  

correctionType        Byte                         ! 1173   0 -  / 1  	
correctionBaseDate	  Long                         ! 1178     ( - yyyy.mm.dd)
correctionBaseNumber  CString(41)	               ! 1179    

Silent                Bool(False)                  !    ( - )
NoAdvanceName         Bool(False)                  !    1030  

bValidateMarkingCodes Byte(0)                      !      :
                                                   ! 0 -      ,    [M-];
                                                   ! 1 -     ,   gCheckResponse.validateMarks;
                                                   ! 2 -            qItems.gImcParams.

gCheckResponse        Group(Atol:G_CheckResponse). !    (    bValidateMarkingCodes = 1)

gOperator             Group(Atol:G_Operator).      !   ()
gClientInfo           Group(Atol:G_ClientInfo).    ! 1256   
gCompanyInfo          Group(Atol:G_CompanyInfo).   ! 1117   
gAgentInfo            Group(Atol:G_AgentInfo).     ! 1057      (    )
gSupplierInfo         Group(Atol:G_SupplierInfo).  ! 1224  
gOperationInfo        Group(Atol:G_OperationInfo). ! 1270    (  )
                                                   
gIndustryInfo         Group(Atol:G_IndustryInfo),    Dim( 3).  ! 1261                                             
gCustomParameters     Group(Atol:G_CustomParameters),Dim( 3).  !  
gSalesNotice          Group(Atol:G_SalesNotice),     Dim( 3).  !  
gTaxes                Group(Atol:G_Tax),             Dim( 6).  !    ( 6  )
gPayments             Group(Atol:G_Payments),        Dim(11).  !     ( 11  )
                   end

!!!      
Atol:Q_Items           Queue,Type
name                     CString(129)              ! 1030       128  
                                                   ! (.  5  2      14.09.2020  -7-20/662@)
price                    Decimal(13,2,0)           !                                                  
quantity                 Decimal(13,3,0)           ! 1023 -
amount                   Decimal(13,2,0)           !  ( 0 ->   Quantity * Price)
infoDiscountAmount       Decimal(13,2,0)           !  
department               Byte(1)                   ! 

measurementUnit	         CString(41)               ! 2108                 (  >= 1.2)
Unit                     CString(41)               ! 1197     (  <  1.2)

Piece                    Bool(False)               !   .         

paymentMethod            CString(41)               ! 1214   a  ! Atol::Nick1214() -> CString(41)
paymentObject            CString(41)               ! 1212    ! Atol::Nick1212() -> CString(41)

gTax                     Group(Atol:G_Tax).        !  

additionalAttribute      CString(121)              ! 1191    
additionalAttributePrint Bool(True)                !      (  - true)

exciseFlag               Bool(False)               !   (     ?!)
exciseSum                Decimal(13,2,0)           ! 1229  

countryCode              CString(21)               ! 1230   
customsDeclaration       CString(81)               ! 1231   

userParam3               Real                      !    3
userParam4               Real                      !    4
userParam5               Real                      !    5
userParam6               Real                      !    6

itemFractionalAmount	 CString( 41)              ! 1291    
Dump                     CString(256)              ! -  ( ) -    

!nomenclatureCode        CString(99)                  ! 1162    BASE64 ( Dump,    !)
!markingCode             Group(Atol:G_MarkingCode).   !     < 1.2   nomenclatureCode

gOutItem                 Group(Atol:G_OutItem).                  !   
gAgentInfo               Group(Atol:G_AgentInfo).                ! 1222     
gSupplierInfo            Group(Atol:G_SupplierInfo).             !  
gImcParams               Group(Atol:G_ImcParams).                !             (   >= 1.2)
gIndustryInfo            Group(Atol:G_IndustryInfo),Dim(3).      ! 1260   (   >= 1.2)
gProductCodes            Group(Atol:G_Codes).                    ! 1163           (   >= 1.2)
gCustomParameters        Group(Atol:G_CustomParameters),Dim(6).  !  
                       end
        
!!!  Atol10
Atol10              Class,Type, Module('atol.clw'), Link('atol.clw')
DllHandle             Long                            !   DLL   
FlagLoaded            Bool(False)                     !     
fptr                  libfptr_handle                  !       
 
TapeWidthSym          uShort                          !     
TapeWidthPix          uShort                          !     
fnFfdVersion          Decimal(7,2)                    ! 1190     (  String)

ErrorNumber           Long                            !  
ErrorText             CString(256)                    !    
DebugCodePage         Long(-1),Private                !       (  = -1)
TimeOutCheckOneMark   Byte(0)                         !       

TmpBuffer             &IDynStr                        !   
TlvBuffer             &IDynStr                        !   

qTextItems            &Atol:Q_OutItems                !          
qPostItems            &Atol:Q_OutItems                !       
                                                   
gRegistrationInfo     Group(Atol:G_RegistrationInfo). !   
gConnect              Group(Atol:G_Connect).          !    

gOperator             Group(Atol:G_Operator).         !   (     )
ReopeningShift        Byte(0)                         !     :
                                                      ! 0 -  ( !       !)
                                                      ! 1 - ,     Z-    
                                                      ! 2 - ,   
Construct             Procedure
Destruct              Procedure
Init                  Procedure(Long lDebugCodePage = -1),Long,Proc
Kill                  Procedure(),Long,Proc

!!!     (Atol Load Method)
ALM                   Procedure(String sNameMethod),Long,Private

!!!     
Connect               Procedure
!!!    
Open                  Procedure
!!!    
Close                 Procedure(Bool bForced = False)
!!!     
Opened                Procedure(),Long

!!!  /     
SetNoMessage          Procedure(Bool bNoMessage)
!!!    
ErrorCode             Procedure(),Long
ErrorMessage          Procedure(String sNameProcedure)
ErrorDescription      Procedure(),String
GetErrorText          Procedure(Long lStringSize),String,Private

!!!   /  / JSON
Debug                 Procedure(String sFileName,String   sText,  Long lTextCodePage = CP_UTF8),Private
Debug                 Procedure(String sFileName,*IDynStr iBuffer,Long lTextCodePage = CP_UTF8),Private
Debug                 Procedure(String sFileName,*cJSON   jObject,Long lTextCodePage = CP_UTF8),Private

!!!    
OpenDialog            Procedure(Long lWindowHandle = 0),Long,Proc
!!!     10
Version               Procedure(),String

!!!   () 
OperatorLogin         Procedure(*Atol:G_Operator gOperator),Private

!!!  
Beep                  Procedure
!!!   
LineFeed              Procedure
!!!  
DevicePowerOff        Procedure
!!!  
DeviceReboot          Procedure

!!!    
UpLoadPictureCliche   Procedure
!!!  
PrintCliche           Procedure
!!!    
ClearPictures         Procedure

!!!    
CheckOpened           Procedure(),Bool

SetHeader             Procedure(String xText_),Private                 !     
SetFooter             Procedure(String xText_),Private                 !    

!****************************************************

GetSettings           Procedure(),STRING
QueryData             Procedure(),LONG,PROC
FNQueryData           Procedure(),LONG,PROC                            !   
GetParam              Procedure(STRING sParam),STRING
SetParam              Procedure(STRING sParam, STRING sText)
UtilFormTlv           Procedure(*IDynStr xBuffer_)                     !   

ReadModelFlags        Procedure                                        !   
ParamApply            Procedure

GetParamStr           Procedure(LONG lParam),STRING
GetParamInt           Procedure(LONG lParam),LONG
GetParamBool          Procedure(LONG lParam),LONG
GetParamDouble        Procedure(LONG lParam),REAL
GetParamBiteArray     Procedure(LONG lParam),STRING

ResetParams           Procedure(),Long,Proc                            !   ???

SetParamStr           Procedure(LONG lParam, STRING sText)
SetParamInt           Procedure(LONG lParam, LONG lValue)
SetParamBool          Procedure(LONG lParam, BYTE bValue)
SetParamDouble        Procedure(LONG lParam, REAL dValue)
SetParamBiteArray     Procedure(LONG lParam, STRING sValue)
SetParamDateTime      Procedure(LONG lParam, <LONG lDate>, <LONG lTime>)

utilFormNomenclature  Procedure(*IDynStr xBuffer_)                     !   
ParseMarkingCode      Procedure                                        !   

PrintReport           Procedure(*Atol:G_Operator gOperator, Long lReportType),Byte,Proc

GetLastCheck          Procedure(),Long                                 !    
UpdateFnmKeys         Procedure(Byte xErrorMessage_ = True)            !   -

Validate              Procedure(Byte xThisCheck_),Private              !    
ReceiptCheck          Procedure(),Byte                                 !  
ShowInfoText          Procedure(<String sText>),Private                !    

  Compile('*** LEGACY ***',Atol:Legacy = 1)
  
! ---      

 !*** LEGACY *** 

! ---    JSON 

!!!  JSON 
jProcess                          Procedure(String jStr),Bool,Proc,Private
jProcess                          Procedure(*cJSON jObj,String sUploadToFile,Bool bAddOutItems = False),Bool,Proc,Private
!!!   JSON    
jRun                              Procedure(*Group gRequest,String sOption,String sUploadToFile,Bool bAddOutItems = False),Bool,Proc,Private
!!!     
jEasyAsk                          Procedure(String sTypeName),Bool,Proc
!!!      
jEasyToGroup                      Procedure(Byte bVid,String sNameObject,*Group gResponse,String sOption),Bool,Proc
!!!      
jEasyToQueue                      Procedure(Byte bVid,String sNameObject,*Queue qResponse,String sOption),Bool,Proc
!!!         
jGetTagValue                      Procedure(String sNameDebug,String sTag),String
!!!         
jCheckVatinSeller                 Procedure(String sVatinSeller),Bool,Proc
!!!    JSON 
jExecuteFromFile                  Procedure(<String sJsonFileName>),Bool,Proc
!!!   JSON    
jValidateJson                     Procedure(String jStr),Bool,Private

!!!    
jGetDeviceInfo                    Procedure(*Atol:G_DeviceInfo gDeviceInfo),Bool,Proc
!!!   
jGetDeviceStatus                  Procedure(*Atol:G_DeviceStatus gDeviceStatus),Bool,Proc
!!!    
jGetRegistrationInfo              Procedure(*Atol:G_RegistrationInfo gGetRegistrationInfo),Bool,Proc
!!!  /  
jRegistration                     Procedure(*Atol:G_Registration gRegistration,*Atol:G_DocParams gDocParams),Bool,Proc
!!!        
jGetTapeWidth                     Procedure(),Private
!!!     
jSetDateTime                      Procedure(Long lDate = -1, Long lTime = -1)
!!!   
jOpenDrawer                       Procedure
!!!    
jGetCashDrawerStatus              Procedure
!!!    
jGetFnInfo                        Procedure(*Atol:G_FnInfo gFnInfo),Bool,Proc 
!!!   
jGetFnStatus                      Procedure(*Atol:G_FnStatus gFnStatus),Bool,Proc 
!!!      
jDisplayFnStatus                  Procedure(),Bool,Proc
!!!  
jCloseArchive                     Procedure(*Atol:G_Operator gOperator,Bool bElectronically = False,*Atol:G_DocParams gDocParams),Bool,Proc 
!!!      /    
jGetLicenses                      Procedure(*Atol:Q_Licenses qLicenses),Bool,Proc
!!!    
jGetMcu                           Procedure(*Atol:G_Mcu gMcu),Bool,Proc 
!!!    
jGetDeviceParameters              Procedure(*Atol:Q_DeviceParameters qExchange),Bool,Proc
!!!   
jSetDeviceParameters              Procedure(*Atol:Q_DeviceParameters qExchange),Bool,Proc

!!!  
jOpenShift                        Procedure(*Atol:G_Operator gOperator,Bool bElectronically = False,Bool bPrintText = True),Bool,Proc
!!!   (  Z-)  
jCloseShift                       Procedure(*Atol:G_Operator gOperator,Bool bElectronically = False,Bool bPrintText = True),Bool,Proc
!!!    
jShiftOpened                      Procedure(),Bool
!!!    
jGetShiftStatus                   Procedure(*Atol:G_ShiftStatus gShiftStatus),Bool

!!!         
jGetCheckTag                      Procedure(Long lNumber,String sTag),String
!!!      
jGetFnDocument                    Procedure(Long lNumber,*Queue qFile,*Queue qContent,Bool bWithRawData = False),Bool,Proc
!!!      
jPrintFnDocument                  Procedure(Long lNumber)
!!!       
jPrintDocumentsFromJournal        Procedure(Long lFrom,Long lTo,Byte bFilter = 1),Bool,Proc
!!!        
jGetCheckTaxationType             Procedure(Byte bTaxType),Byte
!!!         
jRusCheckTaxationName             Procedure(Byte bTaxType),String

!!!  
jPrintReport                      Procedure(*Atol:G_Operator gOperator,Long lReportType),Bool,Proc
!!!    
jReportOfdExchangeStatus          Procedure(*Atol:G_Operator gOperator,<*Atol:G_ReportOfdExchangeStatus gReportOfdExchangeStatus>),Bool,Proc
!!!     
jOfdExchangeStatus                Procedure(*Atol:G_OfdExchangeStatus gOfdExchangeStatus),Bool,Proc
!!!    / 
jReportFnRegistrations            Procedure(),Bool,Proc
!!!   
jGetShiftTotals                   Procedure(*Atol:G_GetShiftTotals gGetShiftTotals),Bool,Proc
!!!   
jGetOverallTotals                 Procedure(*Atol:G_GetOverallTotals gGetOverallTotals),Bool,Proc
!!!       
jGetDepartmentSum                 Procedure(*Atol:G_GetDepartmentSum gGetDepartmentSum),Bool,Proc

!!!  
jPrintText                        Procedure(String sText,     Bool bOpenDrawer = False)
jPrintText                        Procedure(*IDynStr xIBuffer,Bool bOpenDrawer = False)
!!!   
jPrintTextItems                   Procedure(<String sUploadToFile>),Byte,Proc
!!!      /   
jAddOutItemsToPacket              Procedure(*cJSON jDocument,String sTagName),Private
!!!        
jAddOutItemsToDocument            Procedure(*cJSON jDocument,*Atol:Q_OutItems qOutItems,String sTagName),Private  
!!!     
jAddOutItemToArray                Procedure(*Atol:G_OutItem gOutItem,*cJSON jArray),Bool,Proc,Private
!!!      
jAddSeparateToArray               Procedure(*cJSON jArray),Bool,Proc,Private
!!!      
jAddEasyHeader                    Procedure(String sText)
!!!       
jAddEasyFooter                    Procedure(String sText) 
!!!     
jFreeItems                        Procedure(<*Atol:Q_Items qItems>)

!!!    
jCreateNewCheck                   Procedure(*Atol:G_Header        gHeader, |
                                           <*Atol:Q_Items         qItems>, |
                                           <*Atol:Q_ValidateMarks qValidateMarks>)
                                           
!!!       
jContinueCheck                    Procedure
!!!    
jPrintLastReceiptCopy             Procedure
!!!    
jCashInOut                        Procedure(*Atol:G_Header gHeader),Bool,Proc              
!!!   
jPrintCheck                       Procedure(*Atol:G_Header gHeader,*Atol:Q_Items qItems),Bool,Proc
!!!     
jPingIsm                          Procedure(Bool bErrorMessage = True)
!!!    
jCheckImcTime                     Procedure(*Atol:G_CheckImcTime gCheckImcTime),Bool,Proc 
!!!     -
jClearMarkingCodeValidResult      Procedure(),Bool,Proc
!!!   
jCancelMarkingCodeValidation      Procedure(),Bool,Proc
!!!    
jDeclineMarkingCode               Procedure(),Bool,Proc
!!!   
jAcceptMarkingCode                Procedure(<*Atol:G_ItemInfoCheckResult gItemInfoCheckResult>),Bool,Proc
!!!   
jBeginMarkingCodeValidation       Procedure(*Atol:G_ImcParams gImcParams,                 |
                                            *Atol:G_OfflineValidation gOfflineValidation, |
                                            Bool bNotSendToServer = False,                |
                                            Bool bNotFormRequest  = False),Bool,Proc
!!!    
jGetMarkingCodeValidation         Procedure(*Atol:G_ValidateMark gValidateMark),Bool,Proc
!!!                                       
jCheckOneMarkingCode              Procedure(*Atol:G_ImcParams gImcParams,                 |
                                            *Atol:G_OfflineValidation gOfflineValidation, |
                                            *Atol:G_ValidateMark gValidateMark,           |
                                            Bool bNotSendToServer = False,                |
                                            Bool bNotFormRequest  = False),Bool,Proc
!!!     
jIsmExchangeStatus                 Procedure(*Atol:G_IsmExchangeStatus gIsmExchangeStatus),Bool,Proc
!!!    
jCheckMarkingCodeValidationsReady  Procedure(bool bMessage = False),Bool,Proc
!!!     
jCheckImcWorkState                 Procedure(*Atol:G_CheckImcWorkState gCheckImcWorkState),Bool,Proc
!!!   
jValidateMarks                     Procedure(*Atol:Q_ImcParams     qImcParams, |
                                             *Atol:Q_ValidateMarks qValidateMarks, |  
                                             Long lTimeOut = 60000),Bool,Proc  

!!!       
jAddMarksToBuffer                  Procedure(*Atol:Q_ImcParams qImcParams,*Atol:Q_AddMarksToBuffer qAddMarksToBuffer),Bool,Proc 
!!!   
jBatchVerifyMarkingCode            Procedure(*Atol:G_Header gHeader,*Atol:Q_Items qItems),Bool,Proc 
                    end